<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sl="http://www.buergerkarte.at/namespaces/securitylayer/1.2#">
  <xsl:output method="html" encoding="ISO-8859-1" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
  <xsl:template match="/">
    <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
        <title>Stylesheet: Resultat</title>
      </head>
      <body>
        <xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="sl:GetPropertiesResponse">
    <table border="1" bgcolor="silver">
      <tbody>
        <xsl:for-each select="*">
          <tr>
            <td>
              <xsl:if test="self::sl:ViewerMediaType">Anzeigeformat</xsl:if>
              <xsl:if test="self::sl:XMLSignatureTransform">XMLDSIG-Transformation</xsl:if>
              <xsl:if test="self::sl:KeyboxIdentifier">
                <xsl:text>Schlssel (</xsl:text>
                <xsl:if test='string(@Signature)="1" or string(@Signature)="true"'>Signatur</xsl:if>  
                <xsl:if test='string(@Encryption)="1" or string(@Encryption)="true"'>, Verschlsselung</xsl:if>  
                <xsl:text>)</xsl:text>              
              </xsl:if>
              <xsl:if test="self::sl:Binding">Transport-Protokoll</xsl:if>
              <xsl:if test="self::sl:ProtocolVersion">Protokoll-Version</xsl:if>
            </td>
            <td><code>
              <xsl:choose>
                <xsl:when test="self::sl:Binding"><xsl:value-of select="@Identifier"/></xsl:when>
                <xsl:otherwise><xsl:value-of select="./text()"/></xsl:otherwise>
              </xsl:choose>
            </code></td>
          </tr>
        </xsl:for-each>
      </tbody>
    </table>
  </xsl:template>
</xsl:stylesheet>
