package sl12tutorial;

import java.io.IOException;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class DataURL extends HttpServlet
{
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    doGet(request, response);
  }
  
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    // Pr�fen, ob Aufruf von BKU �ber DataURL kommt
    String useParam = request.getParameter("use"); 
    if (useParam != null && "dataurl".equals(useParam))
    {
      // Falls ja, XML-Befehlsantwort auswerten sowie finale Seite erzeugen und senden
      processDataURL(request, response);
    }
    else
    {
      // Falls nein, Startseite erzeugen und senden
      processInitial(request, response);
    }
  }
  
  private void processInitial(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    String servletURL = request.getRequestURL().toString();
//    String servletURL = "http://localhost:18080/SL12Tutorial/DataURL";
        
    String bkuURL = "http://127.0.0.1:3495/http-security-layer-request";
//    String bkuURL = "http://127.0.0.1:13495/http-security-layer-request";
    
    // Startseite erzeugen und senden
    response.setStatus(200);
    response.setContentType("text/html");
    printForm(response, servletURL, bkuURL);
  }
  
  private void processDataURL(HttpServletRequest request, HttpServletResponse response)
    throws IOException
  {
    String xMLResponse = request.getParameter("XMLResponse");
    
    // Antwortseite erzeugen und senden
    response.setStatus(200);
    response.setContentType("text/html");
    printResponse(response, xMLResponse);
  }

  private void printForm(HttpServletResponse response, String servletURL, String bkuURL) throws IOException
  {
    ServletOutputStream out = response.getOutputStream();
    out.println("<html>");
    out.println("<head><title>DataURL: Start</title></head>");
    out.println("<body>");
    out.println("<form method=\"post\" action=\"" + bkuURL + "\">");
    out.println("<input name=\"XMLRequest\" type=\"hidden\" value=\"&lt;?xml version='1.0' encoding='UTF-8'?>&lt;NullOperationRequest xmlns='http://www.buergerkarte.at/namespaces/securitylayer/1.2#'/>\"/>");
    out.println("<input name=\"DataURL\" type=\"hidden\" value=\"" + servletURL + "?use=dataurl" + "\"/>");
    out.println("<input name=\"Request absenden\" type=\"submit\"/>");
    out.println("</form>");
    out.println("</body>");
    out.println("</html>");
  }

  private void printResponse(HttpServletResponse response, String xMLResponse) throws IOException
  {
    ServletOutputStream out = response.getOutputStream();
    out.println("<html>");
    out.println("<head>");
    out.println("<title>DataURL: Auswertung</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<p>Die Antwort von der BKU ist eingetroffen:</p>");
    xMLResponse = xMLResponse.replaceAll("<", "&lt;");
    out.println("<p><pre style=\"background-color: silver;\">" + xMLResponse + "</pre></p>");
    out.println("</body>");
    out.println("</html>");
  }
}
