package sl12tutorial;

import java.io.IOException;
import java.net.URL;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Stylesheet extends HttpServlet
{
  private static final String BKU_URL_ = "http://127.0.0.1:3495/http-security-layer-request"; 
//private static final String BKU_URL_  "http://127.0.0.1:13495/http-security-layer-request";

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    doGet(request, response);
  }
  
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    // Prfen, ob Aufruf von BKU ber DataURL gekommen ist
    String useParam = request.getParameter("use"); 
    if (useParam != null && "dataurl".equals(useParam))
    {
      // Falls ja, XML-Befehlsantwort auswerten und </ok> senden
      processDataURL(request, response);
    }
    else
    {
      // Falls nein, Startseite erzeugen und senden
      processInitial(request, response);
    }
  }
  
  private void processInitial(HttpServletRequest request, HttpServletResponse response) throws IOException
  {
    String servletURL = request.getRequestURL().toString();
//    String servletURL = "http://localhost:18080/SL12Tutorial/Stylesheet";
        
    URL requestURL = new URL(request.getRequestURL().toString());
    String stylesheetURL = 
      requestURL.getProtocol() + "://" + 
      requestURL.getAuthority() +
      request.getContextPath() + "/stylesheet.xslt";
    
    // Startseite erzeugen und senden
    response.setStatus(200);
    response.setContentType("text/html");
    printForm(response, servletURL, stylesheetURL);
  }

  private void processDataURL(HttpServletRequest request, HttpServletResponse response)
    throws IOException
  {
    String xMLResponse = request.getParameter("XMLResponse");
    
    // Verarbeitung der empfangenen Antwort, hier nicht nher ausgefhrt 

    // <ok/> an BKU senden
    response.setStatus(200);
    response.setContentType("text/plain");
    response.getOutputStream().print("<ok/>");
  }
  
  private void printForm(HttpServletResponse response, String servletURL, String stylesheetURL) throws IOException
  {
    ServletOutputStream out = response.getOutputStream();
    out.println("<html>");
    out.println("<head><title>Stylesheet: Start</title></head>");
    out.println("<body>");
    out.println("<form method=\"post\" action=\"" + BKU_URL_ + "\">");
    out.println("<input name=\"XMLRequest\" type=\"hidden\" value=\"&lt;?xml version='1.0' encoding='UTF-8'?>&lt;GetPropertiesRequest xmlns='http://www.buergerkarte.at/namespaces/securitylayer/1.2#'/>\"/>");
    out.println("<input name=\"DataURL\" type=\"hidden\" value=\"" + servletURL + "?use=dataurl" + "\"/>");
    out.println("<input name=\"StylesheetURL\" type=\"hidden\" value=\"" + stylesheetURL +  "\"/>");
    out.println("<input name=\"Request absenden\" type=\"submit\"/>");
    out.println("</form>");
    out.println("</body>");
    out.println("</html>");
  }
}
